<?php

/**
 * @desc Disable/Enable error reporting
 * Use 'E_ALL' for all errors, '0' for nothing (without quotes)
 */
#error_reporting(E_ALL);
error_reporting(0);

require "utils.php";
require "m3u.class.php";

#************************************************#
#                   do.php                       #
#             Authorc: Kopyniak Andrii           #
#                April 05, 2012                  #
#                                                #
#          iPhone Controlled VOD v.1.1 (demo)    #
#************************************************#
# Short manual
#************************************************#
# cmd = ls ([folder_url]) | pls ([ctr, url, name])
# ctr = get (url) | put (url) | append (url) 
# | move (url, name) | make (name)
# | remove (url)
#************************************************#

date_default_timezone_set ('Europe/Kiev');
header ('Content-type: text/xml; charset=utf-8', true);

#echo "Content-type: text/xml; charset=utf-8\r\n\r\n";

#$_ENV['TZ']="EST5EDT";

#$QUERY_ARRAY = explode ('&', $_ENV['QUERY_STRING']);
#foreach ($QUERY_ARRAY as $value)
#{
#  $name_and_value = explode ("=", $value);
#  $_GET[strtolower ($name_and_value[0])] = $name_and_value[1];
#}

# main command
$CMD = (string)(isset ($_GET["cmd"]))?($_GET["cmd"]):('');
#TODO: $FOLDER_URL and $URL decode
# list directory

#// bad for '+' %2b
#$FOLDER_URL = urldecode ((isset ($_GET['folder_url']))?($_GET['folder_url']):(''));
$FOLDER_URL = ((isset ($_GET['folder_url']))?($_GET['folder_url']):(''));

# playlist manager
$CTR = (isset ($_GET['ctr']))?($_GET['ctr']):('');
$URL = urldecode ((isset ($_GET['url']))?($_GET['url']):(''));
$NAME = basename((isset($_GET['name']))?($_GET['name']):(''));

$ROOT_DIR = "/tmp/mnt/storage/";
$pattern = '/^\/tmp\/mnt\/storage/i';
$PLAYLIST_DIR = '/flashdata/plugins_data/remote-control/playlists/';

// debug
#$ROOT_DIR="D:/tmp/types/";
#$pattern = '/^D:\\\tmp\\\types/i';

$xmlstr="<?xml version='1.0' ?><command_result><param name='protocol_version' value='2'/></command_result>";
$xml = simplexml_load_string($xmlstr);

switch (strtolower($CMD)) // cmd = ls | pls "
{
  case 'pls':

    switch (strtolower($CTR))
    {
      case 'get':

        if(is_dir($PLAYLIST_DIR))
        {
          //TODO: check $URL-FILE

          if(file_exists($URL) && filetype($URL) == "file")
          {
            $ext = explodeExt('.', $URL, -2);

            switch ( strtolower(isset($ext[1])?($ext[1]):('')) )
            {
              case 'm3u': case 'm3u8':
                $m3uParser = new m3uParser($URL);

                if(count($m3uParser->getLocations()))
                {

                  $command_status = $xml->addChild('param');
                  $command_status->addAttribute('name', 'command_status');
                  $command_status->addAttribute('value', 'ok');

                  $player_state = $xml->addChild('param');
                  $player_state->addAttribute('name', 'player_state');
                  $player_state->addAttribute('value', (string)$CMD);

                  $pls_ctr = $xml->addChild('param');
                  $pls_ctr->addAttribute('name', 'pls_ctr');
                  $pls_ctr->addAttribute('value', (string)$CTR);

                  $pls_name = $xml->addChild('param');
                  $pls_name->addAttribute('name', 'pls_name');
                  $pls_name->addAttribute('value', (string)$URL);

                  $pls_ver = $xml->addChild('param');
                  $pls_ver->addAttribute('name', 'pls_ver');
                  $pls_ver_val = $m3uParser->getVersion();
                  $pls_ver->addAttribute('value', ($pls_ver_val <= 1)?'#M3U':'#EXTM3U');

                  $items = $xml->addChild('items');

                  foreach($m3uParser->getLocations() as $key => $value)
                  {
                    $item = $items->addChild('item');

                    if ($pls_ver_val == 2)
                    {
                      $m3uParser->getExtInfo($key, $len, $title);
                      $pls_extinf = $item->addChild('extinf');
                      $pls_extinf->addAttribute('len', $len);
                      $pls_extinf->addAttribute('title', $title);
                    }

                    $pls_url = $item->addChild('param');
                    $pls_url->addAttribute('name', 'url');
                    $pls_url->addAttribute('value', (string)$value);
                  }
                }
                break;
              default:
                MakeError($xml, "invalid_parameters", "'url' parameter is missing");
            }
          }
          else
          {
            MakeError($xml, "invalid_parameters", "'url' parameter is missing");
          }
        }
        else
        {
          MakeError($xml, "internal_error", __LINE__ . ": Permission denied or environment fail");
        }
        break;
      case 'put': case 'append':
        if(is_dir($PLAYLIST_DIR))
        {
          if(file_exists($URL) && filetype($URL) == "file")
          {
            $ext = explodeExt('.', $URL, -2);

            switch ( strtolower(isset($ext[1])?($ext[1]):('')) )
            {
              case 'm3u': case 'm3u8':

                $GET_HTTP_RAW_POST_DATA = "<?xml version='1.0' ?><empty></empty>";
                $HTTP_RAW_POST_DATA = ((isset($HTTP_RAW_POST_DATA))?($HTTP_RAW_POST_DATA):($GET_HTTP_RAW_POST_DATA));
                $input_xml = simplexml_load_string((isset($HTTP_RAW_POST_DATA))?($HTTP_RAW_POST_DATA):($GET_HTTP_RAW_POST_DATA));

                /*hack*/
                //{
                //  for($i = 1; $i < 3; $i++)
                //  {
                //    $pls_item = $input_xml->addChild('item');
                //    $pls_param = $pls_item->addChild('param');
                //    $pls_param->addAttribute('name', 'url');
                //    $pls_param->addAttribute('value', "/{path}/$i");
                //  }
                //}
                /*end hack*/

                if($input_xml->xpath('/items') != false)
                {
                  $command_status = $xml->addChild('param');
                  $command_status->addAttribute('name', 'command_status');
                  $command_status->addAttribute('value', 'ok');

                  $player_state = $xml->addChild('param');
                  $player_state->addAttribute('name', 'player_state');
                  $player_state->addAttribute('value', (string)$CMD);

                  $pls_ctr = $xml->addChild('param');
                  $pls_ctr->addAttribute('name', 'pls_ctr');
                  $pls_ctr->addAttribute('value', (string)$CTR);

                  $playlist_data = '';
                  if($input_xml->xpath('/items/item/param') != false)
                  {
                    $pls_items = $xml->addChild('items');

                    foreach ($input_xml->item as $item)
                    {
                      foreach ($item->param as $param)
                      {
                        switch( strtolower((string) $param['name']))
                        { // Получение атрибутов элемента по индексу
                          case 'url':
                            $pls_item = $pls_items->addChild('item');
                            //echo $param['value'].PHP_EOL;
                            $pls_param = $pls_item->addChild('param');
                            $pls_param->addAttribute('key', 'url');
                            $pls_param->addAttribute('value', $param['value']);
                            $playlist_data .= $param['value']."\n";
                            break;
                        }
                      }
                    }
                  }

                  switch( strtolower($CTR))
                  {
                    case 'put':
                      $fp = fopen($URL, 'w');
                      break;
                    case 'append':
                      $fp = fopen($URL, 'a');
                      break;
                  }
                  if($fp)
                  {
                    fwrite($fp, $playlist_data);
                    fclose($fp);
                  }
                  else
                  {
                    MakeError($xml, "internal_error", "Permission denied");
                  }
                }
                else
                {
                  MakeError($xml, "operation_failed", "unsupported format data");
                  $pls_raw_data = $xml->addChild('http_raw_post_data', $HTTP_RAW_POST_DATA);
                }
                break;
              default:
                MakeError($xml, "invalid_parameters", "'url' parameter is missing");
            }
          }
          else
          {
            MakeError($xml, "operation_failed", "URL doesn`t exist");
          }
        }
        else
        {
          MakeError($xml, "internal_error", __LINE__ . ": Permission denied or environment fail");
        }
        break;
      case 'move':
        if(is_dir($PLAYLIST_DIR))
        {
          //TODO: check $URL-FILE

          if(file_exists($URL) && filetype($URL) == "file")
          {
            $ext = explodeExt('.', $URL, -2);

            switch ( strtolower(isset($ext[1])?($ext[1]):('')) )
            {
              case 'm3u': case 'm3u8':
                //$playlist_file_buffer = file_get_contents($PLAYLIST_DIR . $URL);
                //TODO: fix newname.
                $OLDNAME=$URL;
                $ONLY_PATH=explodeExt('/', $URL, -2);
                $NEWNAME=$ONLY_PATH[0] . "/" . $NAME;

                if(rename($OLDNAME, $NEWNAME))
                {
                  $command_status = $xml->addChild('param');
                  $command_status->addAttribute('name', 'command_status');
                  $command_status->addAttribute('value', 'ok');

                  $player_state = $xml->addChild('param');
                  $player_state->addAttribute('name', 'player_state');
                  $player_state->addAttribute('value', (string)$CMD);

                  $pls_ctr = $xml->addChild('param');
                  $pls_ctr->addAttribute('name', 'pls_ctr');
                  $pls_ctr->addAttribute('value', (string)$CTR);
                }
                else
                {
                  MakeError($xml, "internal_error", "Permission denied");
                }
                break;
              default:
                MakeError($xml, "invalid_parameters", "'url' parameter is missing");
            }
          }
          else
          {
            MakeError($xml, "invalid_parameters", "'url' parameter is missing");
          }
        }
        else
        {
          MakeError($xml, "internal_error", __LINE__ . ": Permission denied or environment fail");
        }
        break;
      case 'make':
        if(is_dir($PLAYLIST_DIR))
        {
          $ext = explodeExt('.', $PLAYLIST_DIR . $NAME, -2);

          switch ( strtolower(isset($ext[1])?($ext[1]):('')) )
          {
            case 'm3u': case 'm3u8':
              if(!file_exists($PLAYLIST_DIR . $NAME))
              {
                if (fopen($PLAYLIST_DIR . $NAME, "x"))
                {
                  $command_status = $xml->addChild('param');
                  $command_status->addAttribute('name', 'command_status');
                  $command_status->addAttribute('value', 'ok');

                  $player_state = $xml->addChild('param');
                  $player_state->addAttribute('name', 'player_state');
                  $player_state->addAttribute('value', (string)$CMD);

                  $pls_ctr = $xml->addChild('param');
                  $pls_ctr->addAttribute('name', 'pls_ctr');
                  $pls_ctr->addAttribute('value', (string)$CTR);
                }
                else
                {
                  MakeError($xml, "internal_error", "Permission denied");
                }
              }
              else
              {
                MakeError($xml, "internal_error", "file '$NAME' is exists");
              }
              break;
            default:
              MakeError($xml, "invalid_parameters", "'url' parameter is missing");
          }
        }
        else
        {
          if(!mkdir($PLAYLIST_DIR))
          {
            MakeError($xml, "internal_error", "Permission denied");
          }
        }
        break;
      case 'remove':
        if(is_dir($PLAYLIST_DIR))
        {
          //TODO: check $URL-FILE
          if(file_exists($URL) && filetype($URL) == "file")
          {
            $ext = explodeExt('.', $URL, -2);

            switch ( strtolower(isset($ext[1])?($ext[1]):('')) )
            {
              case 'm3u': case 'm3u8':
                //$playlist_file_buffer = file_get_contents($PLAYLIST_DIR . $URL);
                //TODO: fix newname.
                if(unlink($URL))
                {
                  $command_status = $xml->addChild('param');
                  $command_status->addAttribute('name', 'command_status');
                  $command_status->addAttribute('value', 'ok');

                  $player_state = $xml->addChild('param');
                  $player_state->addAttribute('name', 'player_state');
                  $player_state->addAttribute('value', (string)$CMD);

                  $pls_ctr = $xml->addChild('param');
                  $pls_ctr->addAttribute('name', 'pls_ctr');
                  $pls_ctr->addAttribute('value', (string)$CTR);
                }
                else
                {
                  MakeError($xml, "internal_error", "Permission denied");
                }
                break;
              default:
                MakeError($xml, "invalid_parameters", "'url' parameter is missing");
            }
          }
          else
          {
            MakeError($xml, "invalid_parameters", "'url' parameter is missing");
          }
        }
        else
        {
          MakeError($xml, "internal_error", __LINE__ . ": Permission denied or environment fail");
        }
        break;
      default:
        unset($CTR);

        if ( ! is_dir ($PLAYLIST_DIR))
        {
          if ( ! mkdir ($PLAYLIST_DIR))
            MakeError($xml, "internal_error", "Permission denied");
        }

        if( is_dir($PLAYLIST_DIR))
        {
          $popd = getcwd ();
          chdir ($PLAYLIST_DIR);
          $devices = glob ($PLAYLIST_DIR, (GLOB_MARK | GLOB_ONLYDIR));
          chdir ($popd);

          if($devices != false)
          {
            $FOLDER_URL = $devices[0];
          }
          else
          {
            $FOLDER_URL = $PLAYLIST_DIR;
            if( !mkdir ($FOLDER_URL))
            {
              MakeError ($xml, "internal_error", "Permission denied");
              break;
            }
          }
          $ROOT_DIR = '';
        }
    }

    if ( !empty ($CTR))
      break;

      case 'ls':

        if( is_dir ($ROOT_DIR . $FOLDER_URL) )
        {
          if(strcmp ($CMD,'ls') == 0)
          {
            $popd = getcwd ();
            chdir ($ROOT_DIR . $FOLDER_URL);
            $current_dir = getcwd ();

            if (!preg_match ( $pattern, $current_dir))
            {
              $FOLDER_URL='';
            }
            chdir ($popd);
          }

          $command_status = $xml->addChild ('param');
          $command_status->addAttribute ('name', 'command_status');
          $command_status->addAttribute ('value', 'ok');

          $player_state = $xml->addChild ('param');
          $player_state->addAttribute ('name', 'player_state');
          $player_state->addAttribute ('value', (string)$CMD);

          $items = $xml->addChild ('items');

          $files = scandir ($ROOT_DIR . $FOLDER_URL);

          foreach ($files as $key => $value)
          {
            $item = $items->addChild ('item');

            $ls_name = $item->addChild ('param');
            $ls_name->addAttribute ('name', 'ls_name');
            $ls_name->addAttribute ('value', (string)$value);

            if (filetype ($ROOT_DIR . $FOLDER_URL . '/' . (string)$value) == "dir")
            {
              $ls_type = $item->addChild('param');
              $ls_type->addAttribute('name', 'ls_type');
              $ls_type->addAttribute('value', "folder");

              $ls_icon_url = $item->addChild('param');
              $ls_icon_url->addAttribute('name', 'ls_icon_url');
              $ls_icon_url->addAttribute('value', '');

              $stat = stat($ROOT_DIR . $FOLDER_URL . '/' . $value);

              /* Запускаем функцию для текущего каталога */
              $metadata = array('file' => 0, 'dir' => 0);
              if (($value == '.') || ($value == '..'))
              {
                $ls_metadata = $item->addChild('param');
                $ls_metadata->addAttribute('name', 'ls_metadata');
                $ls_metadata->addAttribute('value',
                  'size: ' . _format_bytes($stat['size']));
              }
              else
              {
                GetMetadata($ROOT_DIR . $FOLDER_URL . '/' . (string)$value, $metadata);

                $ls_metadata = $item->addChild('param');
                $ls_metadata->addAttribute('name', 'ls_metadata');
                $ls_metadata->addAttribute('value',
                  'size: ' . _format_bytes($stat['size']) .
                  ' files: ' . $metadata['file'] .
                  ' dirs: ' . $metadata['dir']);
              }

              $ls_metadata->addAttribute('mime',
                mime_content_type ($ROOT_DIR . $FOLDER_URL . '/' . (string)$value));
            }
            else
            {
              $ext = explodeExt('.', $value, -2);

              //TODO: змінити на назалежній регістр.
              switch ( strtolower(isset($ext[1])?($ext[1]):('')) )
              {
                case 'mp3': case 'ac3': case 'wma': case 'ogg': case 'ogm': case 'm4a':
                case 'aif': case 'iff': case 'mid': case 'mpa': case 'ra': case 'wav':

                case 'flac': case 'ape': case 'vorbis': case 'aac':
                  $ls_type = $item->addChild('param');
                  $ls_type->addAttribute('name', 'ls_type');
                  $ls_type->addAttribute('value', 'audio' );
                  break;

                case 'avi': case 'mp4': case 'mpg': case 'mpeg': case 'divx': case 'm4v':
                case '3gp': case 'asf': case 'wmv': case 'mkv': case 'mov': case 'ogv':
                case 'vob': case 'flv': case 'ts': case '3g2': case 'swf': case 'asf':

                case 'ps': case 'qt': case 'm2ts':
                  $ls_type = $item->addChild('param');
                  $ls_type->addAttribute('name', 'ls_type');
                  $ls_type->addAttribute('value', 'video' );
                  break;

                case 'm3u': case 'm3u8':
                  $ls_type = $item->addChild('param');
                  $ls_type->addAttribute('name', 'ls_type');
                  $ls_type->addAttribute('value', 'playlist' );

                  $ls_type = $item->addChild('param');
                  $ls_type->addAttribute('name', 'ls_pls_url');
                  $ls_type->addAttribute('value', $FOLDER_URL . $value );
                  break;

                case 'png': case 'jpg': case 'jpeg': case 'bmp': case 'gif': case 'psd':
                case 'pspimage': case 'thm': case 'tif': case 'yuf': case 'svg': case 'aai':
                case 'ico': case 'djpg': case 'dbmp': case 'dpng':
                  $ls_type = $item->addChild('param');
                  $ls_type->addAttribute('name', 'ls_type');
                  $ls_type->addAttribute('value', 'image' );
                  break;

                default:
                  $ls_type = $item->addChild('param');
                  $ls_type->addAttribute('name', 'ls_type');
                  $ls_type->addAttribute('value', 'unknown' );
              }

              $ls_icon_url = $item->addChild('param');
              $ls_icon_url->addAttribute('name', 'ls_icon_url');
              $ls_icon_url->addAttribute('value', '');

              $stat = stat($ROOT_DIR . $FOLDER_URL . '/' . $value);

              $ls_metadata = $item->addChild('param');
              $ls_metadata->addAttribute('name', 'ls_metadata');
              $ls_metadata->addAttribute('value',
                'size: ' . _format_bytes($stat['size']));

              $ls_metadata->addAttribute('mime',
                mime_content_type ($ROOT_DIR . $FOLDER_URL . '/' . (string)$value));
            }
          }
        }
        else
        {
          MakeError($xml, "invalid_parameters", __LINE__ . ": 'folder_url' parameter is missing - ".
          $ROOT_DIR . $FOLDER_URL);
          $FOLDER_URL='';
        }

        break;
      default:
        MakeError($xml, "unknown_command", "'cmd' parameter is missing");
}

echo $xml->asXML();
